Ant on the Tree CodeForces - 29D(Lca+暴力)

Connected undirected graph without cycles is called a tree. Trees is a class of graphs which is interesting not only for people, but for ants too.

An ant stands at the root of some tree. He sees that there are n vertexes in the tree, and they are connected by n - 1 edges so that there is a path between any pair of vertexes. A leaf is a distinct from root vertex, which is connected with exactly one other vertex.

The ant wants to visit every vertex in the tree and return to the root, passing every edge twice. In addition, he wants to visit the leaves in a specific order. You are to find some possible route of the ant.

Input
The first line contains integer n (3 ≤ n ≤ 300) — amount of vertexes in the tree. Next n - 1 lines describe edges. Each edge is described with two integers — indexes of vertexes which it connects. Each edge can be passed in any direction. Vertexes are numbered starting from 1. The root of the tree has number 1. The last line contains k integers, where k is amount of leaves in the tree. These numbers describe the order in which the leaves should be visited. It is guaranteed that each leaf appears in this order exactly once.

Output
If the required route doesn’t exist, output -1. Otherwise, output 2n - 1 numbers, describing the route. Every time the ant comes to a vertex, output it’s index.

Examples
Input
3
1 2
2 3
3
Output
1 2 3 2 1
Input
6
1 2
1 3
2 4
4 5
4 6
5 6 3
Output
1 2 4 5 4 6 4 2 1 3 1
Input
6
1 2
1 3
2 4
4 5
4 6
5 3 6
Output
-1
题意:要按照给定的叶子节点的顺序去遍历整棵树,判断是否合理,如果合理的话最后输出路径。
思路:我们dfs的时候处理出所有的根节点到叶子节点的路径。之后找出两个叶子节点的lca,暴力找出他们之间的路径。所有的处理完之后,判断经过的节点个数是否为2*n-1。
代码如下:

#include<bits/stdc++.h>
#define ll long long
using namespace std;

const int maxx=3e2+10;
struct node{
	int to,next;
}e[maxx<<1];
int head[maxx];
int lef[maxx];
int in[maxx],deep[maxx];
int dp[maxx][26];
int ans[1000005];
int n,tot,sign;
vector<int> p[maxx];
/*---------事前准备--------*/
inline void init()
{
	memset(head,-1,sizeof(head));
	tot=0;
}
inline void add(int u,int v)
{
	e[tot].to=v,e[tot].next=head[u],head[u]=tot++;
}
/*------------dfs------------*/
inline void dfs(int u,int f)
{
	deep[u]=deep[f]+1;
	dp[u][0]=f;
	for(int i=1;i<=20;i++)
	{
		if(dp[u][i-1]) dp[u][i]=dp[dp[u][i-1]][i-1];
		else break;
	}
	p[u]=p[f];//vector存储路径
	for(int i=head[u];i!=-1;i=e[i].next)
	{
		int to=e[i].to;
		if(to==f) continue;
		p[u].push_back(to);
		dfs(to,u);
		p[u].pop_back();
	}
}
/*-----------lca----------*/
inline int get_lca(int x,int y)
{
	if(deep[x]<deep[y]) swap(x,y);
	int tmp=deep[x]-deep[y];
	for(int i=0;i<=20;i++)
	{
		if(tmp&(1<<i)) x=dp[x][i];
	}
	if(x==y) return x;
	for(int i=20;i>=0;i--)
	{
		if(dp[x][i]!=dp[y][i])
		{
			x=dp[x][i];
			y=dp[y][i];
		}
	}
	return dp[x][0];
}
int main()
{
	int x,y;
	scanf("%d",&n);
	init();
	for(int i=1;i<n;i++)
	{
		scanf("%d%d",&x,&y);
		add(x,y);
		add(y,x);
		in[x]++,in[y]++;
	}
	int k=0;
	for(int i=2;i<=n;i++) if(in[i]==1) k++;
	for(int i=1;i<=k;i++) scanf("%d",&lef[i]);
	p[0].push_back(1);
	dfs(1,0);
	int cnt=0;
	for(int i=0;i<p[lef[1]].size();i++) ans[++cnt]=p[lef[1]][i];
	for(int i=2;i<=k;i++)//由于n就300,数据量很小,所以暴力找。
	{
		int Lca=get_lca(lef[i-1],lef[i]);
		int x=lef[i-1],y=lef[i];
		for(int j=p[x].size()-2;;j--)
		{
			ans[++cnt]=p[x][j];
			if(p[x][j]==Lca) break;
		}
		int flag=0;
		for(int j=0;j<p[y].size();j++)
		{
			if(p[y][j]==Lca) flag=1;
			else if(flag==1)
			{
				ans[++cnt]=p[y][j];
			}
		}
		if(cnt>2*n-1)
		{
			puts("-1");
			return 0;
		}
	}
	for(int i=p[lef[k]].size()-2;i>=0;i--) ans[++cnt]=p[lef[k]][i];
	if(cnt!=2*n-1) puts("-1");
	else 
	{
		for(int i=1;i<=cnt;i++) cout<<ans[i]<<" ";
		cout<<endl;
	}
	return 0;
}

努力加油a啊,(o)/~

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 打赏
    打赏
  • 0
    评论
CodeForces - 616D是一个关于找到一个序列中最长的第k好子段的起始位置和结束位置的问题。给定一个长度为n的序列和一个整数k,需要找到一个子段,该子段中不超过k个不同的数字。题目要求输出这个序列最长的第k好子段的起始位置和终止位置。 解决这个问题的方法有两种。第一种方法是使用尺取算法,通过维护一个滑动窗口来记录\[l,r\]中不同数的个数。每次如果这个数小于k,就将r向右移动一位;如果已经大于k,则将l向右移动一位,直到个数不大于k。每次更新完r之后,判断r-l+1是否比已有答案更优来更新答案。这种方法的时间复杂度为O(n)。 第二种方法是使用枚举r和双指针的方法。通过维护一个最小的l,满足\[l,r\]最多只有k种数。使用一个map来判断数的种类。遍历序列,如果当前数字在map中不存在,则将种类数sum加一;如果sum大于k,则将l向右移动一位,直到sum不大于k。每次更新完r之后,判断i-l+1是否大于等于y-x+1来更新答案。这种方法的时间复杂度为O(n)。 以上是两种解决CodeForces - 616D问题的方法。具体的代码实现可以参考引用\[1\]和引用\[2\]中的代码。 #### 引用[.reference_title] - *1* [CodeForces 616 D. Longest k-Good Segment(尺取)](https://blog.csdn.net/V5ZSQ/article/details/50750827)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] - *2* [Codeforces616 D. Longest k-Good Segment(双指针+map)](https://blog.csdn.net/weixin_44178736/article/details/114328999)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包

打赏作者

starlet_kiss

你的鼓励将是我创作的最大动力

¥1 ¥2 ¥4 ¥6 ¥10 ¥20
扫码支付:¥1
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值